<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="units[@size]">
    <units size="{@size - count(unit[@id = 'Default']) + 1}">
        <xsl:apply-templates />

        <!-- Add KNIME source features to Source category -->
        <unit id="knime-sources" version="0.0.1.{/repository/properties/property[@name = 'p2.timestamp']/@value}">
          <properties size="3">
            <property name="org.eclipse.equinox.p2.name" value="Sources"/>
            <property name="org.eclipse.equinox.p2.description" value="Sources for KNIME features"/>
            <property name="org.eclipse.equinox.p2.type.category" value="true"/>
          </properties>
          <provides size="1">
            <provided namespace="org.eclipse.equinox.p2.iu" name="knime-sources" version="0.0.1.{/repository/properties/property[@name = 'p2.timestamp']/@value}"/>
          </provides>
          <requires size="{count(unit[contains(@id, '.source.feature.group') or contains(@id, '.source.feature.feature.group')])}">
            <xsl:for-each select="unit[contains(@id, '.source.feature.group') or contains(@id, '.source.feature.feature.group')]">
                <required namespace="org.eclipse.equinox.p2.iu"
                    name="{@id}" range="[{@version},{@version}]" />
            </xsl:for-each>
          </requires>
          <touchpoint id="null" version="0.0.0"/>
        </unit>
    </units>
</xsl:template>

<!-- Remove required entries for source features that do not belong there.
     See https://bugs.eclipse.org/bugs/show_bug.cgi?id=330088
-->
<xsl:template match="unit[contains(@id, '.source.feature.group') or contains(@id, '.source.feature.feature.group')]/requires">
    <xsl:variable name="real-source-entries"
        select="required[(@namespace = 'org.eclipse.equinox.p2.iu') and contains(@name, '.source')]" />
    
    <requires size="{count($real-source-entries)}">
        <xsl:apply-templates select="$real-source-entries" />
    </requires>
</xsl:template>
    

<!-- Remove "Uncategorized" category  -->
<xsl:template match="unit[@id = 'Default']" />

<xsl:template match="@*|node()" priority="-1">
    <xsl:copy><xsl:apply-templates select="@*|node()" /></xsl:copy>
</xsl:template>
</xsl:stylesheet>